/******************************************************************************
 *
 *	Papillon
 *	color edition
 *	PalmOS5
 *	ver 1.1.0
 *	2008.04
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include "defrsc.h"

//#define DEBUG
//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/
void init_level( void );
void init_stroke( void );
void init_enemy_data( EnemyType *, int, Int32, Int32 );
void init_sun( void );
void init_bg( void );
void init_pencil( void );
void move_pencil( void );
void rec_first_stroke( void );
void rec_stroke( void );
void erase_stroke( void );
void draw_stroke( void );
void draw_kill_motion( void );
void draw_sun( void );
void draw_enemy( void );
void draw_pencil( void );
void draw_remainder( void );
void create_enemy( void );
void create_enemy_first( void );
void move_enemy( void );
void kill_enemy( void );
void exec_straight( EnemyType * );
void exec_loop( EnemyType * );
void exec_zigzag( EnemyType * );
void exec_wave_r( EnemyType * );
void exec_wave_l( EnemyType * );
void exec_rest( EnemyType * );
void exec_kill( EnemyType * );
void exec_miss( EnemyType * );
void exec_item( EnemyType * );
void exec_stop_motion( EnemyType * );
void exec_gather( EnemyType * );
void exec_snail( EnemyType * );
void check_bounds( EnemyType * );
void check_move_range( EnemyType * );
void catch_enemy( void );
void get_enemy( void );
void get_item( void  );
void item_exec( void (*)() );
void item_trance( void );
void check_clear( void );
void check_over( void );
void check_circle( void );
Boolean is_in_polygon( int, int );
Boolean is_same( void );
Boolean is_diff( void );
Boolean is_contains_tefu( void );
Boolean is_cross_line( PointType *, PointType *, PointType *, PointType * );
void add_score( void );
void sub_score( void );
void rewound_time( void );
void animetion( void );
PointType calc_cross_point( PointType *, PointType *, PointType *, PointType * );
void release_enemy( void );



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/
extern int sin_tbl[];
extern int cos_tbl[];

static void (*exec_move_tbl[])()
     = { exec_straight, exec_loop, exec_zigzag, exec_rest };



/************************************************
 *	f
 ***********************************************/
void init_demo( void )
{
  Int32 x, y;


  Game.state = GAME_TITLE;
  Game.pause = false;
  Game.active = true;
  Game.catch = false;

  Key.single = Key.keep = 0;
  Pen.down = Pen.move = false;

  Message.wait = 0;
  Message.se = false;

  x = (RND(120)+30) *256;
  y = (RND(110)+35) *256;

  Tefu.num = 0;
  init_enemy_data( &Tefu.buf_p[0], TYPE_SMALL+RND( ENEMY_TYPE_MAX ), x, y );
  Tefu.num++;

  Sound.type = no_sound;
  init_pencil();
  init_stroke();
  init_bg();
}



/************************************************
 *	^Cgf
 ***********************************************/
void
demo( void )
{
  draw_bg();
  show_title();		// ^Cg
  animetion();		// Aj
  move_enemy();		// Xړ
  move_pencil();	// ҂ړ
  catch_enemy();	// X߂܂
  draw_enemy();		// X`
  draw_stroke();	// yOՕ`
  draw_pencil();	// ҂`
  check_circle();	// [vɂȂ
}



/************************************************
 *	Q[JnO
 ***********************************************/
void
pre_start( void )
{
}



/************************************************
 *	Q[̏
 ***********************************************/
void
init_game_status( void )
{
  Game.state = GAME_START;
  Game.pause = false;
  Game.active = true;

  Pen.down = Pen.move = false;

  Player.score = 0;
  Message.wait = 0;
  Message.se = false;

  init_level();
  init_sun();
  init_stroke();

  create_enemy_first();
  Anime.counter = 0;
  rec_first_stroke();
}



/************************************************
 *	Q[̃C
 ***********************************************/
void
play_game( void )
{
  if( TimGetTicks() < Timer.interval + DEF_EVENT_TICK ) return;
  if( Game.active == false ) return;

  // TickXV
  Timer.interval = TimGetTicks();

  get_hard_key();		// n[hL[擾
  if( !select_game_event() )	// eQ[pCxg
    {
      draw_bg();
      animetion();		// Aj
      draw_sun();		// z
      check_circle();		// [vɂȂ
      catch_enemy();		// X߂܂
      create_enemy();		// X
      move_enemy();		// Xړ
      move_pencil();		// ҂ړ
      kill_enemy();		// X폜
      draw_kill_motion();	// ŕ`
      draw_enemy();		// X`
      draw_stroke();		// yOՕ`
      draw_remainder();		// x\
      show_status();		// Xe[^X\
      draw_pencil();		// ҂`
      check_clear();		// xNA
      check_over();		// Q[I[o[
    }
  change_se();			// ʉ؂芷
  show_se_icon();		// ACR\
  copy_buff_to_lcd();		// obNXN[LCDɃRs[
  sound();			// ʉit[j
}



/************************************************
 *	xAbv
 ***********************************************/
void
level_up( void )
{
  if( Lv.level < LAST_LEVEL )
    {
      Lv.level++;
      if( Lv.remainder <= REMAINDER_MAX )
        Lv.remainder += 2;
    }
  Lv.counter = Lv.remainder;

  if( Lv.sp_count <= 0 )
    {
      Lv.special = true;
      Lv.sp_count = SPECIAL_COUNT;
    }
  else
    Lv.special = false;

  if( Lv.level >= 9 )
    {
      Lv.enemy_max = ENEMY_MAX;
      Lv.enemy_nomal_max = ENEMY_NOMAL_MAX;
    }
  else if( Lv.level >= 4 )
    {
      Lv.enemy_max = FIRST_ENEMY_MAX + 2;
      Lv.enemy_nomal_max = ENEMY_NOMAL_MAX;
    }
  init_sun();
  init_bg();
  init_stroke();

  create_enemy_first();
  Anime.counter = 0;
  rec_first_stroke();
}



//////////////////////////////////////////////////////////////////////////////

/************************************************
 *	yOՋL^
 ***********************************************/
static void
rec_first_stroke( void )
{
  Stroke.count = 0;
  Stroke.buf_p[0].x = Pencil.x;
  Stroke.buf_p[0].y = Pencil.y + PENCIL_HEIGHT;
}



/************************************************
 *	yOՋL^
 ***********************************************/
static void
rec_stroke( void )
{
  if( Stroke.hit_period ) return;

  if( Abs( Stroke.buf_p[ Stroke.count ].x - Pencil.x ) <= REC_DOT_RANGE
      && Abs( Stroke.buf_p[ Stroke.count ].y - ( Pencil.y + PENCIL_HEIGHT ) ) <= REC_DOT_RANGE )
    return;

  if( Pen.y >= 160+BACK_H_BLANK )
    return;

  if( Stroke.count >= (STROKE_MAX - 1) )
    erase_stroke();

  Stroke.count++;
  Stroke.buf_p[ Stroke.count ].x = Pencil.x;
  Stroke.buf_p[ Stroke.count ].y = Pencil.y + PENCIL_HEIGHT;
}



/************************************************
 *	҂ړ
 ***********************************************/
static void
move_pencil( void )
{
  if( Pencil.move )
    {
      if( (UInt16) Pen.x - BACK_W_BLANK < 160 && (UInt16) Pen.y - BACK_H_BLANK < 160 )
        {
          Pencil.x = Pen.x - Pencil.dx;
          Pencil.y = Pen.y - Pencil.dy;
          rec_stroke();
        }
    }
}



/************************************************
 *	͂񂾂
 ***********************************************/
static void
check_circle( void )
{
  PointType p0, p1, p2, p3;
  int i, size, max = Stroke.count -2 -1;


  if( Stroke.count <= 2 || Stroke.hit_period ) return;

  p0 = Stroke.buf_p[ Stroke.count -1 ]; // ŌɈC
  p1 = Stroke.buf_p[ Stroke.count ];

  for( i = max; i >= 0; i-- )
    {
      p2 = Stroke.buf_p[i];
      p3 = Stroke.buf_p[i+1];
      if( is_cross_line( &p0, &p1, &p2, &p3 ) )
        {
          // _
          Stroke.buf_p[i] = calc_cross_point( &p0, &p1, &p2, &p3 );
          // obt@l߂
          if( i )
            {
              size = Stroke.count - i;
              MemMove( &Stroke.buf_p[0], &Stroke.buf_p[i], sizeof(PointType) * size );
            }
          Stroke.count = (Stroke.count - i) - 1;
          Stroke.hit_period = HIT_PERIOD;
          return;
        }
    }
}



/************************************************
 *	̌
 * http://www5d.biglobe.ne.jp/~tomoya03/shtml/algorithm/IntersectionEX.htm
 * 
 ***********************************************/
static Boolean
is_cross_line( PointType *p0, PointType *p1, PointType *p2, PointType *p3 )
{
  if( p0 ->x >= p1 ->x )
    {
      if( (p0 ->x < p2 ->x && p0 ->x < p3 ->x) || (p1 ->x > p2 ->x && p1 ->x > p3 ->x) )
        {
          return false;
        }
    }
  else
    {
      if( (p1 ->x < p2 ->x && p1 ->x < p3 ->x) || (p0 ->x > p2 ->x && p0 ->x > p3 ->x) )
        {
          return false;
        }
    }

  if( p0 ->y >= p1 ->y)
    {
      if( (p0 ->y < p2 ->y && p0 ->y < p3 ->y) || (p1 ->y > p2 ->y && p1 ->y > p3 ->y) )
        {
          return false;
        }
    }
  else
    {
      if( (p1 ->y < p2 ->y && p1 ->y < p3 ->y) || (p0 ->y > p2 ->y && p0 ->y > p3 ->y) )
        {
          return false;
        }
    }

  if( ( (p0 ->x - p1 ->x) * (p2 ->y - p0 ->y) + (p0 ->y - p1 ->y) * (p0 ->x - p2 ->x) )
      * ( (p0 ->x - p1 ->x) * (p3 ->y - p0 ->y) + (p0 ->y - p1 ->y) * (p0 ->x - p3 ->x) ) > 0 )
    {
      return false;
    }
  if( ( (p2 ->x - p3 ->x) * (p0 ->y - p2 ->y) + (p2 ->y - p3 ->y) * (p2 ->x - p0 ->x) )
      * ( (p2 ->x - p3 ->x) * (p1 ->y - p2 ->y) + (p2 ->y - p3 ->y) * (p2 ->x - p1 ->x) ) > 0 )
    {
      return false;
    }

  return true;
}



/************************************************
 *	̌_Ƃ߂
 * http://www.dango-itimi.com\blog\archives\2005\000755.html
 * 
 ***********************************************/
static PointType
calc_cross_point( PointType *p0, PointType *p1, PointType *p2, PointType *p3 )
{
  PointType p;
  int dx0 = p1 ->x - p0 ->x;
  int dx1 = p3 ->x - p2 ->x;
  int dy0 = p1 ->y - p0 ->y;
  int dy1 = p3 ->y - p2 ->y;
  double d0 = (double) dy0 / dx0;
  double d1 = (double) dy1 / dx1;
  double x, y;


  // dȂĂ
  if( d0 == d1 || dx0 == dx1 )
    {
      p.x = p1 ->x;
      p.y = p1 ->y;
      return p;
    }

  if( dx0 != 0 && dx1 != 0 )
    {
      x = ( ( p0 ->x * d0 ) - p0 ->y - ( p2 ->x * d1 ) + p2 ->y ) / ( d0 - d1 );
      y = d0 * ( x - p0 ->x ) + p0 ->y;
    }
  else if( dx0 == 0 && dx1 != 0 )     // 
    {
      x = p0 ->x;
      y = d1 * ( x - p2 ->x ) + p2 ->y;
    }
  else if( dx0 != 0 && dx1 == 0 )
    {
      x = p2 ->x;
      y = d0 * ( x - p0 ->x ) + p0 ->y;
    }

  p.x = x + 0.5, p.y = y + 0.5;
  return p;
}



/************************************************
 *	x\
 ***********************************************/
static void
draw_remainder( void )
{
  if( Lv.counter < 0 )
    Lv.counter = 0;

  show_num( 73+BACK_W_BLANK, 148+BACK_H_BLANK, Lv.counter, 2 );
}



/************************************************
 *	yOՕ`
 ***********************************************/
static void
draw_stroke( void )
{
  int i, max = Stroke.count;
  PsetWidthType size = Stroke.hit_period ? bold : nomal;
  IndexedColorType col = INDEX_CIAN;



  if( Stroke.count )
    {
      if( Stroke.hit_period )
        {
          if( !(--Stroke.hit_period) )
            {
              rec_first_stroke();
              return;
            }
        }

      for( i = 1; i <= max; i++ )
        {
          line( Stroke.buf_p[i-1].x, Stroke.buf_p[i-1].y,
                Stroke.buf_p[i].x, Stroke.buf_p[i].y,
                col, size );
        }

      if( Stroke.hit_period )
        {
          line( Stroke.buf_p[0].x, Stroke.buf_p[0].y,
                Stroke.buf_p[Stroke.count].x, Stroke.buf_p[Stroke.count].y,
                col, size );
        }
    }
}



/************************************************
 *	yOՍ폜
 ***********************************************/
static void
erase_stroke( void )
{
  MemMove( &Stroke.buf_p[0],
           &Stroke.buf_p[1],
           sizeof(PointType) * (STROKE_MAX - 1) );
  Stroke.count--;
}



/************************************************
 *	X߂܂H
 ***********************************************/
static void
catch_enemy( void )
{
  int i, max = Tefu.num;
  Boolean catch = false;
  Coord x, y;


  if( !Tefu.num || Stroke.hit_period != HIT_PERIOD ) return;

  MemSet( Judge.count, sizeof(Judge.count), 0 );

  for( i = 0; i < max; i++ )
    {
      x = (Tefu.buf_p[i].x / 256) + Tefu.buf_p[i].cx;
      y = (Tefu.buf_p[i].y / 256) + Tefu.buf_p[i].cy;

      if( (UInt16) x - BACK_W_BLANK >= 160 || (UInt16) y - BACK_H_BLANK >= 160 )
        continue;

      if( is_in_polygon( x, y ) )
        {
          catch = true;
          Game.catch = true; // fp
          Tefu.buf_p[i].state = CATCH_ENEMY;
          Tefu.buf_p[i].dont_move = DONT_MOVE_TIME;
          Tefu.buf_p[i].exec = exec_miss;
          Judge.count[ Tefu.buf_p[i].type ]++;
        }
    }

  if( catch )
    {
      get_enemy( );
      get_item( );
    }

  release_enemy();
}



/************************************************
 *	XQbg
 ***********************************************/
static void
get_enemy( void )
{
  int i, max = Tefu.num;


  if( is_same() || is_diff() )
    {
      for( i = 0; i < max; i++ )
        {
          if( Tefu.buf_p[i].state == CATCH_ENEMY
              && Tefu.buf_p[i].type < TYPE_ITEM_GATHER )
            {
              Tefu.buf_p[i].anime = 3;
              Tefu.buf_p[i].exec = exec_kill;
              Lv.counter--;
            }
        }
      set_se( hit );
      add_score();
    }
  else
    {
      set_se( miss );
      sub_score();
    }
}



/************************************************
 *	ACeQbg
 ***********************************************/
static void
get_item( void )
{
  int i, max = Tefu.num;


  for( i = 0; i < max; i++ )
    {
      if( Tefu.buf_p[i].state == CATCH_ENEMY )
        {
          if( Tefu.buf_p[i].type == TYPE_SNAIL ) // Q
            {
              Tefu.buf_p[i].exec = exec_snail;
              set_se( obstacle );
            }
          else if( Tefu.buf_p[i].type >= TYPE_ITEM_GATHER ) // ACe
            {
              Tefu.buf_p[i].anime = 3;
              Tefu.buf_p[i].exec = exec_kill;
              Tefu.item_num--;
              set_se( item );
            }
        }
    }

  if( Judge.count[ TYPE_SNAIL ] )
    return;

  if( Judge.count[ TYPE_ITEM_STOP ] )
    item_exec( exec_stop_motion );
  else if( Judge.count[ TYPE_ITEM_GATHER ] )
    item_exec( exec_gather );
  else if( Judge.count[ TYPE_ITEM_TRANCE ] )
    item_trance();
}



// ACegp̍sp^[ݒ
static void
item_exec( void (*e)() )
{
  int i, max = Tefu.num;


  for( i = 0; i < max; i++ )
    {
      if( Tefu.buf_p[i].exec != exec_kill
          && Tefu.buf_p[i].type < TYPE_ITEM_GATHER )
        {
          Tefu.buf_p[i].step = DEF_STEP *2;
          Tefu.buf_p[i].exec = e;
        }
    }
}



// ω
static void
item_trance( void )
{
  int i, max = Tefu.num;
  int new = RND( ENEMY_TYPE_MAX );

  for( i = 0; i < max; i++ )
    {
      if( Tefu.buf_p[i].exec != exec_kill
          && Tefu.buf_p[i].type < TYPE_ITEM_GATHER )
        {
          Tefu.buf_p[i].type = new;
        }
    }
}



/************************************************
 *	[X
 ***********************************************/
static void
release_enemy( void )
{
  int i, max = Tefu.num;


  for( i = 0; i < max; i++ )
    {
      if( Tefu.buf_p[i].state == CATCH_ENEMY )
        Tefu.buf_p[i].state = NOMAL_ENEMY;
    }
}



/************************************************
 *	
 ***********************************************/

// F
static Boolean
is_same( void )
{
  int i, count = 0;
  Judge.same = false;


  Judge.same_num = 0;

  if( Judge.count[ TYPE_SNAIL ] )
    return Judge.same;

  for( i = 0; i < ENEMY_TYPE_MAX; i++ )
    {
      if( Judge.count[i] == 1 )
        return Judge.same;
      if( Judge.count[i] >= 2 )
        {
          count++;
          Judge.same_num = Judge.count[i];
        }
    }

  return count == 1 ? Judge.same = true : Judge.same;
}



// ႤF
static Boolean
is_diff( void )
{
  int i, count = 0;


  Judge.diff_num = 0;

  if( Judge.count[ TYPE_SNAIL ] )
    return false;

  for( i = 0; i < ENEMY_TYPE_MAX; i++ )
    {
      if( Judge.count[i] >= 2 )
        return false;
      if( Judge.count[i] == 1 )
        count++;
    }

  if( count >= 3 )
    {
      Judge.diff_num = count;
      return true;
    }
  else
    return false;
}



/************************************************
 *	p`̓_
 * http://www.hiramine.com/programming/graphics/2d_ispointinpolygon.html
 * 
 ***********************************************/
static Boolean
is_in_polygon( int x, int y )
{
  int i, count = 0;
  int max = Stroke.count+1;
  int x0 = Stroke.buf_p[0].x;
  int y0 = Stroke.buf_p[0].y;
  int x1, y1;
  Boolean x0f = (x <= x0);
  Boolean y0f = (y <= y0);
  Boolean x1f, y1f;



  for( i = 1; i < max; i++ )
    {
      x1 = Stroke.buf_p[ i % Stroke.count ].x;
      y1 = Stroke.buf_p[ i % Stroke.count ].y;
      x1f = (x <= x1);
      y1f = (y <= y1);

      if( y0f != y1f )
        {
          if( x0f == x1f )
            {
              if( x0f )
                {
                  count += (y0f ? -1 : 1);
                }
            }
          else
            {
              if( x <= ( x0 + (x1 - x0) * (y - y0 ) / (y1 - y0) ) )
                {
                  count += (y0f ? -1 : 1);
                }
            }
        }
      x0 = x1;
      y0 = y1;
      x0f = x1f;
      y0f = y1f;
    }

  return ( count != 0 );
}



/************************************************
 *	X
 ***********************************************/
static void
kill_enemy( void )
{
  int i, max = Tefu.num;
  EnemyType *cp, *ep;


  if( Tefu.num )
    {
      cp = ep = Tefu.buf_p + (Tefu.num-1);
      for( i = max; i > 0; i--, cp-- )
        {
          if( cp ->state == KILL_ENEMY )
            {
              MemMove( cp, ep, sizeof( EnemyType ) );
              ep--;
              Tefu.num--;
            }
        }
    }
}



/************************************************
 *	XRAZ
 ***********************************************/
static void
add_score( void )
{
  if( Judge.same )
    // F
    Player.score += Judge.same_num * SAME_SCORE;
  else
    // ႤF
    Player.score += Judge.diff_num * DIFF_SCORE;

  // {[iX
  if( Judge.count[ TYPE_SMALL ] )
    {
      Player.score += Judge.count[ TYPE_SMALL] * BONUS_SCORE;
      set_se( bonus );
    }

  // XyVXe[W
  if( Judge.count[ TYPE_SMALL ] && !Lv.special )
    {
      Lv.sp_count -= Judge.count[ TYPE_SMALL ];
    }

  // Ԃ߂
  if( Judge.count[ TYPE_BIG ] )
    {
      rewound_time();
      set_se( rewound );
    }
}



/************************************************
 *	XRAZ
 ***********************************************/
static void
sub_score( void )
{
  if( is_contains_tefu() )
    {
      Player.score = (Int32) Player.score - MISS_SCORE;
      if( (Int32) Player.score < 0 )
        {
          Player.score = 0;
        }
    }
}



static Boolean
is_contains_tefu( void )
{
  int i;


  for( i = 0; i < ENEMY_TYPE_MAX; i++ )
    {
      if( Judge.count[i] )
        return true;
    }

  return false;
}



/************************************************
 *	Ԃ߂
 ***********************************************/
static void
rewound_time( void )
{
  init_sun();
}



/************************************************
 *	x̏
 ***********************************************/
static void
init_level( void )
{
  Lv.level = 1;
  Lv.counter = DEF_REMAINDER;
  Lv.remainder = DEF_REMAINDER;
  Lv.sp_count = SPECIAL_COUNT;
  Lv.enemy_max = FIRST_ENEMY_MAX;
  Lv.enemy_nomal_max = FIRST_NOMAL_MAX;
  Lv.special = false;
}



/************************************************
 *	҂
 ***********************************************/
static void
init_pencil( void )
{
  Pencil.move = false;
  Pencil.x = PENCIL_X+BACK_W_BLANK;
  Pencil.y = PENCIL_Y+BACK_H_BLANK;

  rec_first_stroke();
}



/************************************************
 *	yXg[N
 ***********************************************/
static void
init_stroke( void )
{
  Stroke.count = 0;
  Stroke.hit_period = 0;
}



/************************************************
 *	҂`
 ***********************************************/
static void
draw_pencil( void )
{
  ChrHandleType chr = pencil;

  sprite( Pencil.x, Pencil.y, Bmp.handle[ chr ] );
}



/************************************************
 *	z
 ***********************************************/
static void
init_sun( void )
{
  Sun.x = 0;
  Sun.y = (90+BACK_H_BLANK) *256;
  Sun.period = SUN_PERIOD;
  Sun.anime = 0;
}



/************************************************
 *	wi
 ***********************************************/
static void
init_bg( void )
{
  Bg.handle = Bmp.handle[ BG_BASE_NO + RND(3) ];
}



/************************************************
 *	xNA
 ***********************************************/
static void
check_clear( void )
{
  int i, max = Tefu.num;


  if( Lv.counter <= 0 )
    {
      for( i = 0; i < max; i++ )
        {
          if( Tefu.buf_p[i].exec == exec_kill )
            return;
        }
      Game.state = GAME_CLEAR;
      Pen.down = Pen.move = false;
      Message.wait = MES_WAIT;
      Message.se = true;
    }
}



/************************************************
 *	Q[I[o[
 ***********************************************/
static void
check_over( void )
{
  if( Sun.x > (160+BACK_W_BLANK)*256L )
    {
      Game.state = GAME_OVER;
      Pen.down = Pen.move = false;
      Message.wait = MES_WAIT;
      Message.se = true;
    }
}



/************************************************
 *	Aj
 ***********************************************/
static void
animetion( void )
{
  Anime.counter++;
}



/************************************************
 *	z
 ***********************************************/
static void
draw_sun( void )
{
  int deg;
  ChrHandleType chr = sun1;


  if( ! (--Sun.period) )
    {
      Sun.period = SUN_PERIOD;

      deg = get_deg( (80+BACK_W_BLANK) - (Sun.x / 256 ) + 15,
                     (160+BACK_H_BLANK) - (Sun.y / 256 ) + 15 );
      Sun.x += sin_tbl[ (deg-4+64) & 255 ];
      Sun.y += cos_tbl[ (deg-4+64) & 255 ];
    }

  if( ! (Anime.counter & ANIME_INTERVAL_SUN) )
    Sun.anime ^= 1;

  sprite( Sun.x / 256, Sun.y / 256, Bmp.handle[ chr + Sun.anime ] );
}



/************************************************
 *	ŕ`
 ***********************************************/
static void
draw_kill_motion( void )
{
  int i, max = Tefu.num;
  ChrHandleType chr = kill1;


  for( i = 0; i < max; i++ )
    {
      if( Tefu.buf_p[i].exec == exec_kill )
        {
          sprite( Tefu.buf_p[i].x / 256 + Tefu.buf_p[i].cx-7,
                  Tefu.buf_p[i].y / 256 + Tefu.buf_p[i].cy-7,
                  Bmp.handle[ chr + Tefu.buf_p[i].anime ] );
        }
    }
}



/************************************************
 *	X, ACe`
 ***********************************************/
static void
draw_enemy( void )
{
  int i, max = Tefu.num;
  ChrHandleType chr = tefu1;


  for( i = 0; i < max; i++ )
    {
      if( Tefu.buf_p[i].exec == exec_kill ) continue;
      sprite( Tefu.buf_p[i].x / 256,
              Tefu.buf_p[i].y / 256,
              Bmp.handle[ chr + Tefu.buf_p[i].type * 2 + Tefu.buf_p[i].anime ] );
    }
}



/************************************************
 *	X, ACe, ނ蔭
 ***********************************************/
static void
create_enemy( void )
{
  int max = Lv.enemy_max - Tefu.num;
  Int32 x, y;


  if( Anime.counter & ENEMY_INTERVAL || max <= 0 ) return;

  for( ; max > 0; max-- )
    {
      x = RND(2) ? 8*256L : 168*256L;
      y = (RND(160) + BACK_H_BLANK) *256L;

      if( Lv.special )
        init_enemy_data( &Tefu.buf_p[ Tefu.num ], TYPE_SMALL, x, y );
      else
        init_enemy_data( &Tefu.buf_p[ Tefu.num ], TYPE_NOMAL1+RND( Lv.enemy_nomal_max ), x, y );
    }

  // big
  if( !RND( PROB_BIG ) && Lv.level >= BIG_LEVEL && Sun.x > (70+BACK_W_BLANK) * 256L )
    init_enemy_data( &Tefu.buf_p[ Tefu.num ], TYPE_BIG, x, y );
  // small
  else if( !RND( PROB_SMALL ) && Lv.level >= SMALL_LEVEL )
    init_enemy_data( &Tefu.buf_p[ Tefu.num ], TYPE_SMALL, x, y );
  // item
  else if( !RND( PROB_ITEM ) && Lv.level >= ITEM_LEVEL && Tefu.item_num < ITEM_MAX )
    {
      init_enemy_data( &Tefu.buf_p[ Tefu.num ], TYPE_ITEM_GATHER+RND( ITEM_TYPE_MAX ), x, y );
      Tefu.item_num++;
    }
  // snail
  else if( !RND( PROB_SNAIL ) && Lv.level >= SNAIL_LEVEL && Tefu.snail_num < SNAIL_MAX )
    {
      init_enemy_data( &Tefu.buf_p[ Tefu.num ], TYPE_SNAIL, x, y );
      Tefu.snail_num++;
    }

  Tefu.num++;
}



static void
create_enemy_first( void )
{
  int i;
  Int32 x, y;


  Tefu.num = 0;
  Tefu.item_num = 0;
  Tefu.snail_num = 0;

  for( i = 0; i < INIT_ENEMY_MAX; i++ )
    {
      x = (RND(150)+BACK_W_BLANK) *256;
      y = (RND(150)+BACK_H_BLANK) *256;

      if( Lv.special )
        init_enemy_data( &Tefu.buf_p[ Tefu.num ], TYPE_SMALL, x, y );
      else
        init_enemy_data( &Tefu.buf_p[ Tefu.num ], TYPE_NOMAL1+RND( Lv.enemy_nomal_max ), x, y );

      Tefu.buf_p[ Tefu.num ].exec = exec_move_tbl[ RND(EXEC_MAX) ];

      Tefu.num++;
    }
}



/************************************************
 *	X, ACe, ނ菉
 ***********************************************/
static void
init_enemy_data( EnemyType *w, int type, Int32 x, Int32 y )
{
  static int center[] = {
    5, 4, // small
    7, 8, // big
    7, 6, // nomal1
    7, 6, // nomal2
    7, 6, // nomal3
    7, 6, // nomal4
    6, 6, // item1
    5, 5, // item2
    6, 4, // item3
    7, 5, // snail
  };


  w ->type = type;
  w ->state = NOMAL_ENEMY;
  w ->step = DEF_STEP;
  w ->anime = 0;
  w ->dont_move = 0;
  w ->deg = RND(256);
  w ->x = x;
  w ->y = y;
  w ->cx = center[ type*2 ];
  w ->cy = center[ type*2+1 ];
  w ->exec = exec_straight;

  if( type == TYPE_SNAIL )
    {
      w ->deg = RND(100)+142;
      w ->x = (160+BACK_W_BLANK) *256L;
      w ->exec = exec_snail;
    }
  else if( type >= TYPE_ITEM_GATHER )
    {
      w ->deg = RND(2) ? 1 : 255;
      w ->x = ( RND(140)+BACK_W_BLANK+10 ) *256L;
      w ->y = 0;
      w ->exec = exec_item;
    }
}



/************************************************
 *	X, ACeړ
 ***********************************************/
static void
move_enemy( void )
{
  int i, max = Tefu.num;
  void (*func)( EnemyType * );


  for( i = 0; i < max; i++ )
    {
      func = (void (*)(EnemyType *)) Tefu.buf_p[i].exec;
      func( &Tefu.buf_p[i] );
    }
}



/************************************************
 *	Xړp^[
 ***********************************************/

// i
static void
exec_straight( EnemyType *w )
{
  if( ! (Anime.counter & ANIME_INTERVAL_TEFU) )
    {
      w ->anime ^=1;
      if( RND(3) )
        w ->anime = 0;
    }

  if( ! (w ->step & 127) )
    w ->deg = (w ->deg + (RND(2) ? 16 : -16)) & 255;

  w ->x += sin_tbl[ w ->deg ] / 2;
  w ->y += cos_tbl[ w ->deg ] / 2;
  check_bounds( w );

  if( ! ( --w ->step & DEF_STEP ) )
    w ->exec = exec_move_tbl[ RND( EXEC_MAX ) ];
}


// [v
static void
exec_loop( EnemyType *w )
{
  if( ! (Anime.counter & ANIME_INTERVAL_TEFU) )
    {
      w ->anime ^=1;
      if( RND(3) )
        w ->anime = 0;
    }

  if( ! (w ->step & 1) )
    w ->deg = ((w ->deg)+2) & 255;

  w ->anime = 0;
  w ->x += sin_tbl[ w ->deg ] / 3;
  w ->y += cos_tbl[ w ->deg ] / 3;
  check_bounds( w );

  if( ! ( --w ->step & DEF_STEP ) )
    w ->exec = exec_move_tbl[ RND( EXEC_MAX ) ];
}


// WOUO
static void
exec_zigzag( EnemyType *w )
{
  if( ! (Anime.counter & ANIME_INTERVAL_TEFU) )
    {
      w ->anime ^=1;
      if( RND(3) )
        w ->anime = 0;
    }

  if( ! (w ->step & 31) )
    w ->deg = (w ->deg + (RND(2) ? 64: -64) ) & 255;

  w ->x += sin_tbl[ w ->deg ] / 3;
  w ->y += cos_tbl[ w ->deg ] / 3;
  check_bounds( w );

  if( ! ( --w ->step & DEF_STEP ) )
    w ->exec = exec_move_tbl[ RND( EXEC_MAX ) ];
}


// xe
static void
exec_rest( EnemyType *w )
{
  if( ! (Anime.counter & ANIME_INTERVAL_TEFU) )
    {
      w ->anime ^=1;
    }

  if( ! ( --w ->step & DEF_REST_STEP ) )
    w ->exec = exec_move_tbl[ RND( EXEC_MAX ) ];
}


// ŃAj
static void
exec_kill( EnemyType *w )
{
  int anime = Anime.counter & ANIME_INTERVAL_KILL;

  if( ! anime )
    {
      if( -- w ->anime < 0 )
        {
          w ->state = KILL_ENEMY;
        }
    }
}


// 莞Ԓ~
static void
exec_stop_motion( EnemyType *w )
{
  w ->anime = 0;

  if( ! ( --w ->step & DEF_STEP ) )
    w ->exec = exec_move_tbl[ RND( EXEC_MAX ) ];
}


// ꃖɂ܂
static void
exec_gather( EnemyType *w )
{
  int e = RND(2) ? 4 : -4;


  w ->deg = get_deg( ((80+BACK_W_BLANK)+e) - w ->x / 256,
                     ((80+BACK_H_BLANK)+e) - w ->y / 256 );

  w ->anime = 0;
  w ->x += sin_tbl[ w ->deg ] / 2;
  w ->y += cos_tbl[ w ->deg ] / 2;
  check_bounds( w );

  if( ! ( --w ->step & DEF_STEP ) )
    w ->exec = exec_move_tbl[ RND( EXEC_MAX ) ];
}


// s
static void
exec_miss( EnemyType *w )
{
  int anime = Anime.counter & ANIME_INTERVAL_KILL;


  w -> anime = 0;

  if( !anime )
    {
      if( ! (--w ->dont_move) )
        {
          w ->exec = exec_move_tbl[ RND( EXEC_MAX ) ];
        }
    }
}


// ACẽp^[
static void
exec_item( EnemyType *w )
{
  if( ! (w ->step & 1) )
    {
      if( w ->deg < 70 )
        w ->deg += 2;
      else if( w ->deg == 71 )
        w ->deg = 255;

      if( w ->deg > 186 )
        w ->deg -= 2;
      else if( w ->deg == 185 )
        w ->deg = 1;
    }

  w ->x += sin_tbl[ w ->deg ] / 2;
  w ->y += cos_tbl[ w ->deg ] / 2;

  if( w ->x < 0 )
    w ->x = (160+BACK_W_BLANK) *256L;
  else if( w ->x > (160+BACK_W_BLANK) *256L )
    w ->x = 0;

  if( w ->y > (160+BACK_H_BLANK) *256L )
    {
      w ->state = KILL_ENEMY;
      Tefu.item_num--;
    }

  w ->step = --(w ->step) & DEF_STEP;
}


// ނ
static void
exec_snail( EnemyType *w )
{
  if( ! (Anime.counter & ANIME_INTERVAL_SNAIL) )
    w ->anime ^=1;

  w ->x += sin_tbl[ w ->deg ] / 8;
  w ->y += cos_tbl[ w ->deg ] / 8;

  if( w ->y < 0 )
    w ->y = (160+BACK_H_BLANK) *256L;
  else if( w ->y > (160+BACK_H_BLANK) *256L )
    w ->y = 0;

  if( w ->x < 0 )
    {
      w ->state = KILL_ENEMY;
      Tefu.snail_num--;
    }
}


// E`FbN
static void
check_bounds( EnemyType *w )
{
  if( w ->x < 8*256L )
    w ->x = 8*256L;
  else if( w ->x > 168*256L )
    w ->x = 168*256L;

  if( w ->y < 8*256L )
    w ->y = 8*256L;
  else if( w ->y > 168*256L )
    w ->y = 168*256L;

  if( (w ->x == 8*256L) || (w ->x == 168*256L) || (w ->y == 8*256L) || (w ->y == 168*256L) )
    {
      w ->deg = (w ->deg +128) & 255;
      w ->exec = exec_straight;
    }
}



