/******************************************************************************
 *
 *	Papillon
 *	color edition
 *	PalmOS5
 *	ver 1.1.0
 *	2008.04
 *	ChoiKyun
 *
 *****************************************************************************/

#ifndef INCLUDED_GAME_H
#define INCLUDED_GAME_H


#ifdef GLOBAL_VALUE_DEFINE
#define GLOBAL
#define GLOBAL_VAL(v) = (v)
#else
#define GLOBAL extern
#define GLOBAL_VAL(v)
#endif



/************************************************
 *	萔
 ***********************************************/
// PalmOne SDK
// 5-WAY
#define vchrRockerUp		0x0132		/**< 5-way rocker up */
#define vchrRockerDown		0x0133		/**< 5-way rocker down */
#define vchrRockerLeft		0x0134		/**< 5-way rocker left */
#define vchrRockerRight		0x0135		/**< 5-way rocker right */
#define vchrRockerCenter	0x0136		/**< 5-way rocker center/press */

#define keyBitRockerUp		0x00010000	// 5-way rocker up
#define keyBitRockerDown	0x00020000	// 5-way rocker down
#define keyBitRockerLeft	0x00040000	// 5-way rocker left
#define keyBitRockerRight	0x00080000	// 5-way rocker right
#define keyBitRockerCenter	0x00100000	// 5-way rocker center/press


// o[W
#define appFileCreator		'cK03'
#define appVersionNum		0x01
#define appPrefID		0x00
#define appPrefVersionNum	0x01


// o[W
#define ourMinVersion	sysMakeROMVersion(2,0,0,sysROMStageRelease,0)
#define PalmRomVer300	sysMakeROMVersion(3,0,0,sysROMStageRelease,0)
#define PalmRomVer350	sysMakeROMVersion(3,5,0,sysROMStageRelease,0)
#define PalmRomVer500	sysMakeROMVersion(5,0,0,sysROMStageDevelopment,0) // CLIE΍

// J[
#define TRANS_COLOR 223

#define INDEX_BLACK 215
#define INDEX_GRAY 218
#define INDEX_WHITE 0
#define INDEX_CIAN 90
#define INDEX_MAGENTA 5


// FPS
#define DEF_EVENT_TICK 4
#define SEC 25


// XRAl[
#define DEF_NAME_LEN 5


// Q[̐is
#define GAME_START 1
#define GAME_READY 2
#define GAME_CLEAR 4
#define GAME_OVER 8
#define GAME_TITLE 16


// n[hL[
#define KEY_RIGHT keyBitHard3
#define KEY_LEFT keyBitHard2
#define KEY_UP keyBitPageUp
#define KEY_DOWN keyBitPageDown

#define KEY_1 keyBitHard1
#define KEY_2 keyBitHard2
#define KEY_3 keyBitHard3
#define KEY_4 keyBitHard4

// 5-WAY
#define KEY_NAV_RIGHT keyBitRockerRight
#define KEY_NAV_LEFT keyBitRockerLeft
#define KEY_NAV_CENTER keyBitRockerCenter


// rbg}bv
#define BMP_BASE_ID 1000
#define MAX_BMP 51


// wi
#define BG_BASE_NO 49
#define BG_HEIGHT 160


// XRALO
#define MAX_RANKING 6


// obNXN[TCY
#define BACK_WIDTH (160+16+16)
#define BACK_HEIGHT (160+16+16)
 // E]16hbg
#define BACK_W_BLANK 16
#define BACK_H_BLANK 16
#define BACK_BTM_BLANK 16

#define STATE_HEIGHT 12


// XN[TCY
#define LCD_WIDTH 160
#define LCD_HEIGHT 160
// Q[EBhETCY
#define GAME_WIN_WIDTH 160
#define GAME_WIN_HEIGHT 160


// ʉf[^
#define SND_LENGTH 20


// tHgTCY
#define NUM_WIDTH (7+1)


// I[gp[It
#define AUTO_OFF_TIME (3*60)

////// e평l

// EFCg
#define MES_WAIT (SEC/2) //bZ[Wp


// z
#define SUN_PERIOD 10


// y
#define STROKE_MAX 26

#define PENCIL_X 124
#define PENCIL_Y 124
#define PENCIL_WIDTH 13
#define PENCIL_HEIGHT 12

#define REC_DOT_RANGE 8


// G
#define ENEMY_MAX 9

#define ENEMY_TYPE_MAX 6
#define ITEM_TYPE_MAX 3
#define OBSTACLE_TYPE_MAX 1
#define ENEMY_NOMAL_MAX 4

#define TYPE_SMALL 0
#define TYPE_BIG 1
#define TYPE_NOMAL1 2
#define TYPE_NOMAL2 3
#define TYPE_NOMAL3 4
#define TYPE_NOMAL4 5
#define TYPE_ITEM_GATHER 6
#define TYPE_ITEM_STOP 7
#define TYPE_ITEM_TRANCE 8
#define TYPE_SNAIL 9

#define ENEMY_INTERVAL 15 // oԊu
#define INIT_ENEMY_MAX 4 // zuG

#define EXEC_MAX 4 // sp^[
#define DEF_STEP 255 // s؂ւ
#define DEF_REST_STEP 127

#define ITEM_MAX 2
#define SNAIL_MAX 3

#define PROB_BIG 8 // om
#define PROB_SMALL 6
#define PROB_ITEM 8
#define PROB_SNAIL 12

#define DONT_MOVE_TIME 10 // ~X


// Aj
#define ANIME_INTERVAL_SUN 15
#define ANIME_INTERVAL_TEFU 15
#define ANIME_INTERVAL_KILL 3
#define ANIME_INTERVAL_ITEM 31
#define ANIME_INTERVAL_STOP 15
#define ANIME_INTERVAL_SNAIL 31


// 蔻
#define HIT_PERIOD 10 // 莞

#define KILL_ENEMY -1
#define NOMAL_ENEMY 0
#define CATCH_ENEMY 1


// XRA
#define SAME_SCORE 50
#define DIFF_SCORE 100
#define BONUS_SCORE 500
#define MISS_SCORE 20


// x
#define DEF_REMAINDER 3
#define LAST_LEVEL 40

#define SMALL_LEVEL 5
#define BIG_LEVEL 7
#define ITEM_LEVEL 9
#define SNAIL_LEVEL 11

#define SPECIAL_COUNT 10

#define FIRST_ENEMY_MAX 5
#define FIRST_NOMAL_MAX 2

#define REMAINDER_MAX 37

// f
#define DEMO_WAIT (1*SEC)



/************************************************
 *	}N
 ***********************************************/
// _
#define RND(N) ((((Int32) SysRandom (0)) * (N)) / ((Int32) sysRandomMax + 1))



/************************************************
 *	錾
 ***********************************************/

// LN^ԍ
typedef enum
{
  title,
  se_off,
  se_on,
  status,
  num_0,
  num_1,
  num_2,
  num_3,
  num_4,
  num_5,
  num_6,
  num_7,
  num_8,
  num_9,
  pause,
  game_over,
  tefu1,
  _tefu1,
  tefu2,
  _tefu2,
  tefu3,
  _tefu3,
  tefu4,
  _tefu4,
  tefu5,
  _tefu5,
  tefu6,
  _tefu6,
  item1,
  _item1,
  item2,
  _item2,
  item3,
  _item3,
  snail,
  _snail,
  kill1,
  kill2,
  kill3,
  kill4,
  sun1,
  sun2,
  title_mask,
  clear,
  clear_mask,
  over_mask,
  pause_mask,
  lv,
  pencil,
  bg1
} ChrHandleType;



// ʉԍ
typedef enum
{
  no_sound,	// Ȃ
  down,		// y
  new,		// Go
  miss,		// ~X
  hit,		// ߊl
  item,		// ACe
  bonus,	// {[iX
  obstacle,	// ނ
  rewound,	// Ԋ߂
  g_over,	// Q[I[o[
  g_clear,	// NA
  click,	// NbN
  sound_cnt
} SoundType;



// PSETO[XP[
typedef enum
{
  white,
  light_gray,		// 4KXP[
  dark_gray,
  black
} PsetColorType;


// PSET
typedef enum
{
  nomal,
  bold
} PsetWidthType;


// Q[̐is
typedef struct
{
  UInt16 state;		// Q[istO
  Boolean active;
  Boolean pause;
  Boolean catch;	// fp
} GameStateType;


// vC[
typedef struct
{
  UInt32 score;
} PlayerType;


// x
typedef struct
{
  int level;
  int counter;
  int remainder;
  int sp_count;
  int enemy_max;
  int enemy_nomal_max;
  Boolean special;
} LevelType;


// z
typedef struct
{
  Int32 x;
  Int32 y;
  int period;
  int anime;
} SunType;


// y
typedef struct
{
  Boolean down;			// ytO
  Boolean move;
  Coord x;			// yXW
  Coord y;			// yYW
} PenType;


// L[
typedef struct
{
  UInt32 single;		// L[P
  UInt32 keep;			// L[A
  Boolean first_center;		// Z^[L[dh~tO
} KeyType;


// ʃ[h̕ۑ
typedef struct
{
  UInt32 width;
  UInt32 height;
  UInt32 depth;
} ScreenModeType;


// XN[
typedef struct
{
  ScreenModeType save;		// ʃ[h
  WinHandle back_h;		// obNXN[nh
  void *back_p;			// obNXN[|C^
  void  *lcd_p;			// kbc|C^
} ScreenType;


// rbg}bv
typedef struct
{
  WinHandle handle[ MAX_BMP+1 ];
} BmpType;


// ^C}[
typedef struct
{
  Int32 interval;
} TimerType;


// ʉ
typedef struct
{
  Boolean on;			// ʉtO
  SoundType type;		// ʉԍ
  int repeat;			// ʉJEgit[j
  UInt16 volume;		// {[
} SeType;


// Aj
typedef struct
{
  UInt16 counter;		// AjpJE^
} AnimeType;


// nCXRA
typedef struct
{
  char name[DEF_NAME_LEN+1];	// O
  UInt32 score;			// nCXRA
  char date[dateStringLength];	// t
} HiScoreType;


// LO
typedef struct
{
  char last_name[ DEF_NAME_LEN+1 ];	// Ōɓ͂O
  Int16 pos;				// LO݈ʒu
  HiScoreType ranking[ MAX_RANKING ];	// XRALO
} RankingType;


// Q[vt@@X
typedef struct
{
  RankingType rank;
  Boolean sound;
} GamePrefType;


// bZ[W
typedef struct
{
  Int16 wait;
  Boolean se;
} MessageType;


// Xg[Nf[^
typedef struct
{
  PointType *buf_p;	// yOՃobt@̃|C^
  int count;		// obt@JEg
  int hit_period;	// 蔻̎
} StrokeType;


// ҂
typedef struct
{
  Boolean move;
  Coord x;
  Coord y;
  int dx;
  int dy;
} PencilType;


// G
typedef struct
{
  int type;
  int step;
  int state;
  int anime;
  int dont_move;
  int deg;		// px
  Int32 x;		// W
  Int32 y;
  int cx;		// SW
  int cy;
  void (*exec)();	// s֐
} EnemyType;


// GǗ
typedef struct
{
  EnemyType *buf_p;
  int num;
  int item_num;
  int snail_num;
} EnemyManageType;


// XRA
typedef struct
{
  Boolean same;
  int same_num;
  int diff_num;
  int count[ ENEMY_TYPE_MAX
             +ITEM_TYPE_MAX
             +OBSTACLE_TYPE_MAX ];
} JudgeType;


// wi
typedef struct
{
  WinHandle handle;
} BgType;


// I[gp[It
typedef struct
{
  UInt16 seconds;
} AutoOffType;



/************************************************
 *	O[oϐ
 ***********************************************/
GLOBAL GameStateType Game;
GLOBAL PlayerType Player;
GLOBAL LevelType Lv;
GLOBAL PenType Pen;
GLOBAL KeyType Key;
GLOBAL ScreenType Screen;
GLOBAL BmpType Bmp;
GLOBAL TimerType Timer;
GLOBAL SeType Sound;
GLOBAL AnimeType Anime;
GLOBAL RankingType Rank;
GLOBAL MessageType Message;
GLOBAL PencilType Pencil;
GLOBAL StrokeType Stroke;
GLOBAL EnemyManageType Tefu;
GLOBAL SunType Sun;
GLOBAL JudgeType Judge;
GLOBAL BgType Bg;
GLOBAL AutoOffType AutoOff;


/************************************************
 *	vg^Cv
 ***********************************************/
// starter.c
UInt32 PilotMain( UInt16, MemPtr, UInt16 );
void get_hard_key( void );		// n[hL[擾


// game.c
void init_demo( void );
void demo( void );
void init_game_status( void );		// Q[
void play_game( void );			// Q[C
void pre_start( void );			// Q[JnO̕\,XN[
void level_up( void );


// graphic.c
Err init_screen( void );		// XN[
void clear_screen( void );		// SʃNAiobNXN[j
void copy_buff_to_lcd( void );		// LCD]
void sprite( Coord, Coord, WinHandle );// LN^`i16*8 or 16*16 2bitj
void pset( Coord, Coord,
           IndexedColorType, PsetWidthType );	// PSET
void line( Coord, Coord, Coord, Coord,
           IndexedColorType, PsetWidthType );	// LINE
Boolean point( Coord, Coord, IndexedColorType );// POINT
void draw_bg( void );


// sound.c
void change_se( void );			// ʉ؂ւ
void set_se( SoundType );		// ʉZbg
void sound( void );			// ʉit[j


// score.c
void init_hiscore( void );		// nCXRA
void check_hiscore( UInt32 );		// nCXRAXV
void show_ranking( void );		// LO\
void show_num( Coord, Coord, UInt32, int );	// l\


// message.c
Boolean select_game_event( void );	// e탁bZ[W
void show_status( void );		// Xe[^X\
void show_se_icon( void );		// ACR\
void show_title( void );


// sin.c
int get_deg( int, int );		// px߂



#undef GLOBAL
#undef GLOBAL_VAL



#endif // INCLUDED_GAME_H
